## neovim-qt 0.2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
project(neovim-qt)

INCLUDE(CPack)

if(NOT EXISTS ${NEOVIM_EXEC})
	set(NEOVIM_EXEC nvim)
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
		"${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -std=c++11 -Wfatal-errors")
endif()

option(USE_GCOV "Enable gcov support" OFF)
if(USE_GCOV)
	message(STATUS "Enabling coverage")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
	set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage")
endif()

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# to generate a compile_commands.json usable by ycm and other tooling
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
# konsole_wcwidth.h
include_directories(third-party)

# homebrew/macrpots/fink etc.
include(MacOSXPaths)

# Qt
set(CMAKE_AUTOMOC ON)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Test REQUIRED)

# msgpack
option(USE_SYSTEM_MSGPACK "Use system msgpack libraries " OFF)
if(USE_SYSTEM_MSGPACK)
	find_package(Msgpack REQUIRED)
else()
	add_subdirectory(third-party)
endif()
include_directories(${MSGPACK_INCLUDE_DIRS})

if(CMAKE_BUILD_TYPE STREQUAL "Release")
    add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

# Place targets in bin/ or lib/ for all build configurations
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
foreach(CFGNAME ${CMAKE_CONFIGURATION_TYPES})
  string(TOUPPER ${CFGNAME} CFGNAME)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CFGNAME} ${CMAKE_BINARY_DIR}/bin)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CFGNAME} ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CFGNAME} ${CMAKE_BINARY_DIR}/lib)
endforeach()

if(MSVC)
  # Allow use of deprecated function names in MSVC (read/write)
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
endif()

add_subdirectory(src)
add_subdirectory(doc)

option(ENABLE_TESTS "Build tests" ON)
if(ENABLE_TESTS)
	enable_testing()
	add_subdirectory(test)
	add_subdirectory(src/gui/shellwidget/test)
endif()

# Bindings
find_package(PythonInterp)
if (PYTHONINTERP_FOUND)
	set(NVIM "nvim" CACHE STRING "Path to nvim executable")
	add_custom_target(bindings
		COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/bindings/generate_bindings.py ${NVIM} ${CMAKE_SOURCE_DIR}/src/auto
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		COMMENT "Generating bindings"
		)

	add_custom_target(bindings-preview
		COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/bindings/generate_bindings.py ${NVIM}
		)
endif()

=== third-party/CMakeLists.txt ===
# This is a minimal CMake project to fetch and build third party
# dependencies
cmake_minimum_required(VERSION 2.8.11)
project(neovim-qt-deps)

#
# Get Msgpack
#
set(MSGPACK_VERSION 1.4.0)
set(MSGPACK_URL https://github.com/msgpack/msgpack-c/archive/cpp-${MSGPACK_VERSION}.tar.gz)
set(MSGPACK_SHA256 387a6e7b38b1a316275298cd9c3556630798a3b46ece13942a3b276306222c88)

message(STATUS "Downloading Msgpack...")
set(MSGPACK_TARBALL msgpack-${MSGPACK_VERSION}.tar.gz)
file(DOWNLOAD ${MSGPACK_URL} ${CMAKE_CURRENT_SOURCE_DIR}/${MSGPACK_TARBALL}
	INACTIVITY_TIMEOUT 30
	EXPECTED_HASH SHA256=${MSGPACK_SHA256})
execute_process(COMMAND ${CMAKE_COMMAND} -E tar xfz ${MSGPACK_TARBALL}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	RESULT_VARIABLE rv)
if(NOT rv EQUAL 0)
  message(FATAL_ERROR "Failed to extract ${MSGPACK_TARBALL}")
endif()

set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR})
set(MSGPACK_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/msgpack-c-cpp-${MSGPACK_VERSION}/)
add_subdirectory(${MSGPACK_SOURCE_DIR} EXCLUDE_FROM_ALL)

# Similar enough to FindMsgpack
set(MSGPACK_INCLUDE_DIRS ${MSGPACK_SOURCE_DIR}/include PARENT_SCOPE)
set(MSGPACK_LIBRARIES msgpackc-static PARENT_SCOPE)

=== src/gui/CMakeLists.txt ===
set(QTLIBS Qt5::Network Qt5::Widgets)

include_directories(..)
qt5_add_resources(NEOVIM_RCC_SOURCES data.qrc)
if(WIN32)
	set(RES_FILE "data.rc")
	enable_language(RC)
elseif(APPLE)
	set(ICON_PATH ${PROJECT_SOURCE_DIR}/third-party/neovim.icns)
	set_source_files_properties(${ICON_PATH} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")

	set(MACOSX_BUNDLE_INFO_PLIST ${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in)
endif()

add_subdirectory(shellwidget)

include(GNUInstallDirs)
set(RUNTIME_PATH )
add_library(neovim-qt-gui shell.cpp input.cpp errorwidget.cpp mainwindow.cpp app.cpp
	${CMAKE_SOURCE_DIR}/third-party/konsole_wcwidth.cpp
	${NEOVIM_RCC_SOURCES})
target_link_libraries(neovim-qt-gui qshellwidget neovim-qt)

if(NOT APPLE)
	set_property(SOURCE main.cpp PROPERTY COMPILE_DEFINITIONS
		NVIM_QT_RUNTIME_PATH="${CMAKE_INSTALL_FULL_DATADIR}/nvim-qt/runtime")
endif()

add_executable(nvim-qt WIN32 MACOSX_BUNDLE main.cpp
	${NEOVIM_RCC_SOURCES}
	${RES_FILE}
	${ICON_PATH})

target_link_libraries(nvim-qt ${QTLIBS} ${MSGPACK_LIBRARIES} neovim-qt-gui)

if(APPLE)
	add_custom_command(TARGET nvim-qt COMMAND ${CMAKE_COMMAND} -E copy_directory
		${CMAKE_CURRENT_SOURCE_DIR}/runtime/
		${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/nvim-qt.app/Contents/Resources/runtime
		COMMENT "Copying runtime into bundle")
#	TODO: Bundle Qt, currently conflicts with brew Qt
#	add_custom_command(TARGET nvim-qt COMMAND macdeployqt
#		ARGS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/nvim-qt.app
#		COMMENT "Bundling Qt libraries")
endif()

install(TARGETS nvim-qt DESTINATION ${CMAKE_INSTALL_BINDIR})
if(NOT APPLE)
	install(DIRECTORY runtime
		DESTINATION ${CMAKE_INSTALL_DATADIR}/nvim-qt/)
	install(FILES nvim-qt.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
	install(FILES ${CMAKE_SOURCE_DIR}/third-party/neovim.png
			RENAME nvim-qt.png
			DESTINATION ${CMAKE_INSTALL_DATADIR}/pixmaps/)
endif()

if(WIN32 AND NOT CMAKE_CROSSCOMPILING)
	if(Qt5Core_VERSION VERSION_LESS 5.3)
		message(WARNING "Cannot use windeployqt in Qt 5.2 and earlier")
	else()
		include(WinDeployQt)
		WinDeployQt(TARGET nvim-qt COMPILER_RUNTIME INCLUDE_MODULES ${QTLIBS} EXCLUDE_MODULES webkit webkit2)
		install(DIRECTORY ${PROJECT_BINARY_DIR}/windeployqt/
			DESTINATION ${CMAKE_INSTALL_BINDIR})
	endif()
endif()

=== debian/changelog ===
neovim-qt (0.2.4-1) unstable; urgency=medium

  * New upstream release

 -- Jason Pleau <jason@jpleau.ca>  Sat, 12 Nov 2016 09:24:00 -0500

neovim-qt (0.2.3-1) unstable; urgency=medium

  * Initial release. (Closes: #818112)

 -- Jason Pleau <jason@jpleau.ca>  Wed, 05 Oct 2016 22:22:28 -0400

=== debian/control ===
Source: neovim-qt
Section: editors
Priority: optional
Maintainer: Debian Vim Maintainers <pkg-vim-maintainers@lists.alioth.debian.org>
Uploaders: Jason Pleau <jason@jpleau.ca>, James McCoy <jamessan@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               help2man,
               libmsgpack-dev (>= 1.4.0-2),
               neovim,
               python-jinja2,
               python-msgpack,
               qtbase5-dev,
               xauth,
               xvfb
Standards-Version: 3.9.8
Homepage: https://github.com/equalsraf/neovim-qt
Vcs-Git: https://anonscm.debian.org/cgit/pkg-vim/neovim-qt.git/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-vim/neovim-qt.git/

Package: neovim-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, neovim
Description: neovim client library and GUI
 neovim-qt provides a Qt5 GUI interface for neovim

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

# cmake doesn't honor CPPFLAGS
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON
	$(MAKE) -C $(CURDIR)/build bindings

override_dh_auto_build:
	dh_auto_build --parallel
	xvfb-run --auto-servernum help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt

override_dh_auto_test:
	xvfb-run --auto-servernum dh_auto_test

override_dh_auto_install:
	dh_auto_install
	nvim -i NONE -u NONE -e --headless -c "helptags $(CURDIR)/debian/neovim-qt/usr/share/nvim-qt/runtime/doc" -c "quit"

## neovim-qt 0.2.7

=== debian/changelog ===
neovim-qt (0.2.7-3) unstable; urgency=medium

  * Fix FTBFS by creating a $HOME for the tests.  (Closes: #871132)
  * Declare compliance with police 4.0.1, no changes needed.
  * Explicitly set CMAKE_BUILD_TYPE=Release to disable noisy debug logging.

 -- James McCoy <jamessan@debian.org>  Sat, 12 Aug 2017 20:39:13 -0400

neovim-qt (0.2.7-2) unstable; urgency=medium

  * Upload to unstable

 -- James McCoy <jamessan@debian.org>  Sat, 24 Jun 2017 14:54:45 -0400

neovim-qt (0.2.7-1) experimental; urgency=medium

  [ Jason Pleau ]
  * New upstream release
    + Fix race condition in tst_neovimconnector.  (Closes: #845685)
    + "nvim-qt --help" no longer requires an X connection.
  * Upstream now generates helptags during building, we don't need to do it
    ourselves during dh_install anymore
  * Provide nvim-qt as an alternative for gvim (Closes: #848100)

  [ James McCoy ]
  * Track which neovim we built against using Built-Using.
  * Remove xfvb-run call for generating the man page.

 -- James McCoy <jamessan@debian.org>  Wed, 31 May 2017 22:50:13 -0400

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                qtbase5-dev,
                xauth,
                xvfb
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Homepage: https://github.com/equalsraf/neovim-qt
 Vcs-Git: https://anonscm.debian.org/cgit/pkg-vim/neovim-qt.git/
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-vim/neovim-qt.git/
@@ -21,5 +21,6 @@
 Package: neovim-qt
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, neovim
+Built-Using: ${nvim-qt:Built-Using}
 Description: neovim client library and GUI
  neovim-qt provides a Qt5 GUI interface for neovim

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

# cmake doesn't honor CPPFLAGS
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

TEST_HOME = $(CURDIR)/build/home

BUILT_USING = $(shell dpkg-query --show --showformat='$${source:Package} (= $${source:Version})' neovim)

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release
	$(MAKE) -C $(CURDIR)/build bindings

override_dh_auto_build:
	dh_auto_build --parallel
	help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt

override_dh_auto_test:
	mkdir -p "$(TEST_HOME)"
	xvfb-run --auto-servernum env HOME="$(TEST_HOME)" dh_auto_test

override_dh_gencontrol:
	dh_gencontrol -- "-Vnvim-qt:Built-Using=$(BUILT_USING)"

## neovim-qt 0.2.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
 
 # Qt
 set(CMAKE_AUTOMOC ON)
+find_package(Qt5Core REQUIRED)
 find_package(Qt5Widgets REQUIRED)
 find_package(Qt5Network REQUIRED)
 find_package(Qt5Test REQUIRED)

=== src/CMakeLists.txt ===

set(NEOVIM_QT_SOURCES util.cpp neovimconnector.cpp neovimconnectorhelper.cpp function.cpp msgpackrequest.cpp auto/neovim.cpp msgpackiodevice.cpp)
if(WIN32)
  list(APPEND NEOVIM_QT_SOURCES stdinreader.cpp)
endif()

add_library(neovim-qt STATIC ${NEOVIM_QT_SOURCES})
target_link_libraries(neovim-qt Qt5::Network ${MSGPACK_LIBRARIES})

add_subdirectory(gui)

=== test/CMakeLists.txt ===

include_directories(${CMAKE_SOURCE_DIR}/src)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
function(add_xtest SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${SOURCE_NAME}.cpp ${ARGV1} ${ARGV2})
	target_link_libraries(${SOURCE_NAME} Qt5::Network Qt5::Test ${MSGPACK_LIBRARIES} neovim-qt)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

function(add_xtest_gui SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${SOURCE_NAME}.cpp)
	target_link_libraries(${SOURCE_NAME} Qt5::Network Qt5::Test ${MSGPACK_LIBRARIES} neovim-qt Qt5::Widgets neovim-qt-gui)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME}
		# Run GUI tests from source dir, they depend on src files
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

add_xtest(tst_neovimobject)
add_xtest(tst_neovimconnector)
add_xtest(tst_callallmethods)
add_xtest(tst_encoding)
add_xtest(tst_msgpackiodevice)
add_xtest(tst_input ${CMAKE_SOURCE_DIR}/src/gui/input.cpp)
add_xtest_gui(tst_shell)

=== third-party/CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 #
 # Get Msgpack
 #
-set(MSGPACK_VERSION 1.4.0)
+set(MSGPACK_VERSION 2.1.3)
 set(MSGPACK_URL https://github.com/msgpack/msgpack-c/archive/cpp-${MSGPACK_VERSION}.tar.gz)
-set(MSGPACK_SHA256 387a6e7b38b1a316275298cd9c3556630798a3b46ece13942a3b276306222c88)
+set(MSGPACK_SHA256 42ff5c213fd24bd4388c45c1f21d84b476678ce6366ea4d4f4086618a1d2cd23)
 
 message(STATUS "Downloading Msgpack...")
 set(MSGPACK_TARBALL msgpack-${MSGPACK_VERSION}.tar.gz)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 target_link_libraries(neovim-qt-gui qshellwidget neovim-qt)
 
 if(NOT APPLE)
-	set_property(SOURCE main.cpp PROPERTY COMPILE_DEFINITIONS
+	set_property(SOURCE app.cpp PROPERTY COMPILE_DEFINITIONS
 		NVIM_QT_RUNTIME_PATH="${CMAKE_INSTALL_FULL_DATADIR}/nvim-qt/runtime")
 endif()
 
@@ -64,3 +64,13 @@
 			DESTINATION ${CMAKE_INSTALL_BINDIR})
 	endif()
 endif()
+
+# Generate help tags
+add_custom_command(
+	OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/runtime/doc/tags"
+	COMMAND ${NEOVIM_EXEC} -i NONE -u NONE -e --headless
+	-c "helptags ${CMAKE_CURRENT_SOURCE_DIR}/runtime/doc" -c "quit"
+	COMMENT "Generating helptags")
+
+add_custom_target(helptags ALL
+	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/runtime/doc/tags")

=== src/gui/shellwidget/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
project(qshellwidget)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Qt
set(CMAKE_AUTOMOC ON)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Test REQUIRED)

set(SOURCES shellcontents.cpp helpers.cpp shellwidget.cpp konsole_wcwidth.cpp)
add_library(qshellwidget STATIC ${SOURCES})
target_link_libraries(qshellwidget Qt5::Widgets)

add_executable(example EXCLUDE_FROM_ALL example.cpp)
target_link_libraries(example qshellwidget )
add_executable(example2 EXCLUDE_FROM_ALL example2.cpp)
target_link_libraries(example2 qshellwidget )
add_executable(example3 EXCLUDE_FROM_ALL example3.cpp)
target_link_libraries(example3 qshellwidget )

add_executable(fontinfo EXCLUDE_FROM_ALL fontinfo.cpp)
target_link_libraries(fontinfo Qt5::Widgets )

=== src/gui/shellwidget/test/CMakeLists.txt ===
include_directories(..)

function(add_xtest SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${SOURCE_NAME}.cpp)
	target_link_libraries(${SOURCE_NAME} Qt5::Widgets Qt5::Test qshellwidget)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME})
endfunction()

add_xtest(test_cell)
add_xtest(test_shellcontents)
add_xtest(test_shellwidget)
add_xtest(bench_scroll)
add_xtest(bench_cell)

=== debian/changelog ===
neovim-qt (0.2.8-3) unstable; urgency=medium

  * Increase xvfb-run resolution to fix arm{el,hf} crashes

 -- James McCoy <jamessan@debian.org>  Sun, 28 Jan 2018 08:21:43 -0500

neovim-qt (0.2.8-2) unstable; urgency=medium

  * Change Vcs-* to salsa.d.o
  * Revert "Track neovim version used to build in Built-Using"
  * Declare compliance with Policy 4.1.3
  * Point gbp-dch to the correct branch
  * Bump debhelper compat to 11
  * Set R³ to no

 -- James McCoy <jamessan@debian.org>  Sun, 21 Jan 2018 20:17:50 -0500

neovim-qt (0.2.8-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat to 10
  * Declare compliance with Policy 4.1.0, no changes needed

 -- James McCoy <jamessan@debian.org>  Thu, 14 Sep 2017 23:46:30 -0400

=== debian/control ===
Source: neovim-qt
Section: editors
Priority: optional
Maintainer: Debian Vim Maintainers <pkg-vim-maintainers@lists.alioth.debian.org>
Uploaders: Jason Pleau <jason@jpleau.ca>, James McCoy <jamessan@debian.org>
Build-Depends: debhelper (>= 11),
               cmake,
               help2man,
               libmsgpack-dev (>= 1.4.0-2),
               neovim,
               python-jinja2,
               python-msgpack,
               qtbase5-dev,
               xauth,
               xvfb
Standards-Version: 4.1.3
Rules-Requires-Root: no
Homepage: https://github.com/equalsraf/neovim-qt
Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git
Vcs-Browser: https://salsa.debian.org/vim-team/neovim-qt

Package: neovim-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, neovim
Description: neovim client library and GUI
 neovim-qt provides a Qt5 GUI interface for neovim

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

# cmake doesn't honor CPPFLAGS
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

TEST_HOME = $(CURDIR)/build/home

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release
	$(MAKE) -C $(CURDIR)/build bindings

override_dh_auto_build:
	dh_auto_build
	help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt

override_dh_auto_test:
	mkdir -p "$(TEST_HOME)"
	# Need to use a server with 24bit color depth to avoid libegl-mesa
	# crashes on some systems
	xvfb-run --server-args '-screen 0 1024x768x24' --auto-servernum env HOME="$(TEST_HOME)" dh_auto_test

## neovim-qt 0.2.9

=== src/CMakeLists.txt ===

set(NEOVIM_QT_SOURCES util.cpp neovimconnector.cpp neovimconnectorhelper.cpp function.cpp msgpackrequest.cpp msgpackiodevice.cpp auto/neovimapi0.cpp auto/neovimapi1.cpp auto/neovimapi2.cpp)
if(WIN32)
  list(APPEND NEOVIM_QT_SOURCES stdinreader.cpp)
endif()

add_library(neovim-qt STATIC ${NEOVIM_QT_SOURCES})
target_link_libraries(neovim-qt Qt5::Network ${MSGPACK_LIBRARIES})

add_subdirectory(gui)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,8 @@
 
 include_directories(${CMAKE_SOURCE_DIR}/src)
+if (WIN32 AND USE_STATIC_QT)
+	add_definitions(-DUSE_STATIC_QT)
+endif ()
 
 add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
 function(add_xtest SOURCE_NAME)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,11 @@
 include_directories(..)
 qt5_add_resources(NEOVIM_RCC_SOURCES data.qrc)
 if(WIN32)
+	if (USE_STATIC_QT)
+		add_definitions(-DUSE_STATIC_QT)
+		link_directories(${CMAKE_PREFIX_PATH}/share/qt5/plugins/platforms)
+		set(QTLIBS ${QTLIBS} Qt5PlatformCompositorSupport qwindows)
+	endif()
 	set(RES_FILE "data.rc")
 	enable_language(RC)
 elseif(APPLE)
@@ -57,7 +62,7 @@
 if(WIN32 AND NOT CMAKE_CROSSCOMPILING)
 	if(Qt5Core_VERSION VERSION_LESS 5.3)
 		message(WARNING "Cannot use windeployqt in Qt 5.2 and earlier")
-	else()
+	elseif(NOT DEFINED USE_STATIC_QT)
 		include(WinDeployQt)
 		WinDeployQt(TARGET nvim-qt COMPILER_RUNTIME INCLUDE_MODULES ${QTLIBS} EXCLUDE_MODULES webkit webkit2)
 		install(DIRECTORY ${PROJECT_BINARY_DIR}/windeployqt/

=== src/gui/shellwidget/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,10 @@
 set(CMAKE_AUTOMOC ON)
 find_package(Qt5Widgets REQUIRED)
 find_package(Qt5Test REQUIRED)
+
+if (WIN32 AND USE_STATIC_QT)
+	add_definitions(-DUSE_STATIC_QT)
+endif ()
 
 set(SOURCES shellcontents.cpp helpers.cpp shellwidget.cpp konsole_wcwidth.cpp)
 add_library(qshellwidget STATIC ${SOURCES})

=== debian/changelog ===
neovim-qt (0.2.9-1) unstable; urgency=medium

  * New upstream release
    + Runtime detection of Neovim's supported API versions (Closes: #904265)

 -- James McCoy <jamessan@debian.org>  Wed, 08 Aug 2018 21:34:13 -0400

neovim-qt (0.2.8-4) unstable; urgency=medium

  [ David Rabel ]
  * Fix d/copyright: MacOSXBundleInfo.plist.in was moved

  [ Jason Pleau ]
  * Relax debhelper dependency to allow for easier backporting
  * Update Maintainer email to team+vim@tracker.debian.org

  [ James McCoy ]
  * Declare compliance with Policy 4.1.5, no changes needed.

 -- James McCoy <jamessan@debian.org>  Wed, 04 Jul 2018 21:24:03 -0400

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: neovim-qt
 Section: editors
 Priority: optional
-Maintainer: Debian Vim Maintainers <pkg-vim-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
 Uploaders: Jason Pleau <jason@jpleau.ca>, James McCoy <jamessan@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 11~),
                cmake,
                help2man,
                libmsgpack-dev (>= 1.4.0-2),
@@ -13,7 +13,7 @@
                qtbase5-dev,
                xauth,
                xvfb
-Standards-Version: 4.1.3
+Standards-Version: 4.1.5
 Rules-Requires-Root: no
 Homepage: https://github.com/equalsraf/neovim-qt
 Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git

## neovim-qt 0.2.10

=== src/CMakeLists.txt ===

set(NEOVIM_QT_SOURCES util.cpp neovimconnector.cpp neovimconnectorhelper.cpp function.cpp msgpackrequest.cpp msgpackiodevice.cpp auto/neovimapi0.cpp auto/neovimapi1.cpp auto/neovimapi2.cpp auto/neovimapi3.cpp)
if(WIN32)
  list(APPEND NEOVIM_QT_SOURCES stdinreader.cpp)
endif()

add_library(neovim-qt STATIC ${NEOVIM_QT_SOURCES})
target_link_libraries(neovim-qt Qt5::Network ${MSGPACK_LIBRARIES})

add_subdirectory(gui)

=== third-party/CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 #
 # Get Msgpack
 #
-set(MSGPACK_VERSION 2.1.3)
+set(MSGPACK_VERSION 3.0.1)
 set(MSGPACK_URL https://github.com/msgpack/msgpack-c/archive/cpp-${MSGPACK_VERSION}.tar.gz)
-set(MSGPACK_SHA256 42ff5c213fd24bd4388c45c1f21d84b476678ce6366ea4d4f4086618a1d2cd23)
+set(MSGPACK_SHA256 1b834ab0b5b41da1dbfb96dd4a673f6de7e79dbd7f212f45a553ff9cc54abf3b)
 
 message(STATUS "Downloading Msgpack...")
 set(MSGPACK_TARBALL msgpack-${MSGPACK_VERSION}.tar.gz)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,8 @@
 include(GNUInstallDirs)
 set(RUNTIME_PATH )
 add_library(neovim-qt-gui shell.cpp input.cpp errorwidget.cpp mainwindow.cpp app.cpp
+	popupmenumodel.cpp
+	popupmenu.cpp
 	${CMAKE_SOURCE_DIR}/third-party/konsole_wcwidth.cpp
 	${NEOVIM_RCC_SOURCES})
 target_link_libraries(neovim-qt-gui qshellwidget neovim-qt)

=== debian/changelog ===
neovim-qt (0.2.10-1) unstable; urgency=medium

  * Update to new upstream version 0.2.10.
    + Add support for Neovim's ext_popupmenu UI option to provide a native
      popup menu
      - Add :GuiPopupmenu command to explicitly enable/disable the GUI popup
        menu
    + Add support for Neovim's ext_tabline UI option to provide native tabline
      display
      - Honor 'showtabline' to determine when the tabline is displayed
      - Add :GuiTabline command to explicitly enable/disable the tabline
    + Support the :suspend command, minimizing the GUi
  * Opt-in to debhelper 12 beta
  * rules: Use cmake+ninja buildsystem
  * Declare compliance with Policy 4.2.1
  * copyright: Add license for third-party/oxygen/

 -- James McCoy <jamessan@debian.org>  Mon, 22 Oct 2018 22:20:18 -0400

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,18 @@
 Priority: optional
 Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
 Uploaders: Jason Pleau <jason@jpleau.ca>, James McCoy <jamessan@debian.org>
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper (>= 11.4~),
                cmake,
                help2man,
                libmsgpack-dev (>= 1.4.0-2),
                neovim,
+               ninja-build,
                python-jinja2,
                python-msgpack,
                qtbase5-dev,
                xauth,
                xvfb
-Standards-Version: 4.1.5
+Standards-Version: 4.2.1
 Rules-Requires-Root: no
 Homepage: https://github.com/equalsraf/neovim-qt
 Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git

## neovim-qt 0.2.11

=== debian/changelog ===
neovim-qt (0.2.11-1) unstable; urgency=medium

  * New upstream release

 -- James McCoy <jamessan@debian.org>  Tue, 01 Jan 2019 16:00:54 -0500

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,9 @@
                python-msgpack,
                qtbase5-dev,
                xauth,
+# This can be "neovim (>= 0.3.2) | xclip" once that version of neovim is
+# generally available
+               xclip,
                xvfb
 Standards-Version: 4.2.1
 Rules-Requires-Root: no

## neovim-qt 0.2.12

=== debian/changelog ===
neovim-qt (0.2.12-1) unstable; urgency=medium

  * New upstream release

 -- James McCoy <jamessan@debian.org>  Wed, 23 Jan 2019 23:50:53 -0500

## neovim-qt 0.2.12.1%2Brb2

=== debian/changelog ===
neovim-qt (0.2.12.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Vim Maintainers <team+vim@tracker.debian.org>  Thu, 28 Jan 2021 19:58:51 +0800

## neovim-qt 0.2.12.1+rb2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,9 @@
 cmake_minimum_required(VERSION 2.8.11)
-project(neovim-qt)
+if (POLICY CMP0048)
+  cmake_policy(SET CMP0048 NEW)
+endif (POLICY CMP0048)
+
+project(neovim-qt VERSION 0.2.10.0)
 
 INCLUDE(CPack)

=== src/CMakeLists.txt ===

configure_file(version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(NEOVIM_QT_SOURCES util.cpp neovimconnector.cpp neovimconnectorhelper.cpp function.cpp msgpackrequest.cpp msgpackiodevice.cpp auto/neovimapi0.cpp auto/neovimapi1.cpp auto/neovimapi2.cpp auto/neovimapi3.cpp auto/neovimapi4.cpp)
if(WIN32)
  list(APPEND NEOVIM_QT_SOURCES stdinreader.cpp)
endif()

add_library(neovim-qt STATIC ${NEOVIM_QT_SOURCES})
target_link_libraries(neovim-qt Qt5::Network ${MSGPACK_LIBRARIES})

add_subdirectory(gui)

=== third-party/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 # This is a minimal CMake project to fetch and build third party
 # dependencies
 cmake_minimum_required(VERSION 2.8.11)
+if (POLICY CMP0048)
+  cmake_policy(SET CMP0048 NEW)
+endif (POLICY CMP0048)
 project(neovim-qt-deps)
 
 #

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 include(GNUInstallDirs)
 set(RUNTIME_PATH )
-add_library(neovim-qt-gui shell.cpp input.cpp errorwidget.cpp mainwindow.cpp app.cpp
+add_library(neovim-qt-gui shell.cpp input.cpp treeview.cpp errorwidget.cpp mainwindow.cpp app.cpp
 	popupmenumodel.cpp
 	popupmenu.cpp
 	${CMAKE_SOURCE_DIR}/third-party/konsole_wcwidth.cpp

## neovim-qt 0.2.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
   cmake_policy(SET CMP0048 NEW)
 endif (POLICY CMP0048)
 
-project(neovim-qt VERSION 0.2.10.0)
+project(neovim-qt VERSION 0.2.14.0)
 
 INCLUDE(CPack)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 
 include_directories(${CMAKE_SOURCE_DIR}/src)
+add_definitions(-DCMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\")
 if (WIN32 AND USE_STATIC_QT)
 	add_definitions(-DUSE_STATIC_QT)
 endif ()

=== third-party/CMakeLists.txt ===
--- 
+++ 
@@ -9,9 +9,9 @@
 #
 # Get Msgpack
 #
-set(MSGPACK_VERSION 3.0.1)
+set(MSGPACK_VERSION 3.2.0)
 set(MSGPACK_URL https://github.com/msgpack/msgpack-c/archive/cpp-${MSGPACK_VERSION}.tar.gz)
-set(MSGPACK_SHA256 1b834ab0b5b41da1dbfb96dd4a673f6de7e79dbd7f212f45a553ff9cc54abf3b)
+set(MSGPACK_SHA256 ff865a36bad5c72b8e7ebc4b7cf5f27a820fce4faff9c571c1791e3728355a39)
 
 message(STATUS "Downloading Msgpack...")
 set(MSGPACK_TARBALL msgpack-${MSGPACK_VERSION}.tar.gz)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,11 @@
 set(QTLIBS Qt5::Network Qt5::Widgets)
 
-include_directories(..)
+include_directories(.. shellwidget)
 qt5_add_resources(NEOVIM_RCC_SOURCES data.qrc)
 if(WIN32)
+	set(SRCS_PLATFORM
+		arguments_qwindowgeometry.cpp
+		)
 	if (USE_STATIC_QT)
 		add_definitions(-DUSE_STATIC_QT)
 		link_directories(${CMAKE_PREFIX_PATH}/share/qt5/plugins/platforms)
@@ -11,21 +14,37 @@
 	set(RES_FILE "data.rc")
 	enable_language(RC)
 elseif(APPLE)
+	set(SRCS_PLATFORM
+		arguments_qwindowgeometry.cpp
+		)
 	set(ICON_PATH ${PROJECT_SOURCE_DIR}/third-party/neovim.icns)
 	set_source_files_properties(${ICON_PATH} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
 
 	set(MACOSX_BUNDLE_INFO_PLIST ${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in)
+else()
+	set(SRCS_PLATFORM
+		arguments_geometry.cpp
+		)
 endif()
 
 add_subdirectory(shellwidget)
 
 include(GNUInstallDirs)
 set(RUNTIME_PATH )
-add_library(neovim-qt-gui shell.cpp input.cpp treeview.cpp errorwidget.cpp mainwindow.cpp app.cpp
+
+add_library(neovim-qt-gui
+	app.cpp
+	errorwidget.cpp
+	highlight.cpp
+	input.cpp
+	mainwindow.cpp
+	popupmenu.cpp
 	popupmenumodel.cpp
-	popupmenu.cpp
-	${CMAKE_SOURCE_DIR}/third-party/konsole_wcwidth.cpp
+	shell.cpp
+	treeview.cpp
+	${SRCS_PLATFORM}
 	${NEOVIM_RCC_SOURCES})
+
 target_link_libraries(neovim-qt-gui qshellwidget neovim-qt)
 
 if(NOT APPLE)
@@ -58,7 +77,7 @@
 	install(FILES nvim-qt.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
 	install(FILES ${CMAKE_SOURCE_DIR}/third-party/neovim.png
 			RENAME nvim-qt.png
-			DESTINATION ${CMAKE_INSTALL_DATADIR}/pixmaps/)
+			DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/192x192/apps/)
 endif()
 
 if(WIN32 AND NOT CMAKE_CROSSCOMPILING)

=== src/gui/shellwidget/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,7 @@
 cmake_minimum_required(VERSION 2.8.11)
+if (POLICY CMP0048)
+  cmake_policy(SET CMP0048 NEW)
+endif (POLICY CMP0048)
 project(qshellwidget)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)

=== src/gui/shellwidget/test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
 include_directories(..)
+
+if (WIN32 AND USE_STATIC_QT)
+	add_definitions(-DUSE_STATIC_QT)
+endif ()
 
 function(add_xtest SOURCE_NAME)
 	add_executable(${SOURCE_NAME} ${SOURCE_NAME}.cpp)

=== debian/changelog ===
neovim-qt (0.2.15-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 19:16:48 +0100

neovim-qt (0.2.15-1) unstable; urgency=medium

  * New upstream release
  * Build-Depend on python3-{jinja2,msgpack} (Closes: #943130)

 -- James McCoy <jamessan@debian.org>  Sun, 03 Nov 2019 23:00:44 -0500

neovim-qt (0.2.13-1) unstable; urgency=medium

  * New upstream release
  * Update to debhelper 12 and debian-compat Build-Depends
  * Declare compliance with Policy 4.4.0, no changes needed
  * Reduce xclip Build-Depends to an alternative.  Neovim >= 0.3.2 allows a
    clipboard provider to be implemented in VimL, which neovim-qt does and
    uses for its tests.
  * Move /usr/bin/gvim.nvim-qt to /usr/libexec/nvim-qt/gvim, since it's only
    used for the gvim alternative.

 -- James McCoy <jamessan@debian.org>  Tue, 03 Sep 2019 23:19:54 -0400

=== debian/control ===
Source: neovim-qt
Section: editors
Priority: optional
Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
Uploaders: Jason Pleau <jason@jpleau.ca>, James McCoy <jamessan@debian.org>
Build-Depends: debhelper-compat (= 12),
               cmake,
               help2man,
               libmsgpack-dev (>= 1.4.0-2),
               neovim,
               ninja-build,
               python3-jinja2,
               python3-msgpack,
               qtbase5-dev,
               xauth,
               neovim (>= 0.3.2) | xclip,
               xvfb
Standards-Version: 4.4.0
Rules-Requires-Root: no
Homepage: https://github.com/equalsraf/neovim-qt
Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git
Vcs-Browser: https://salsa.debian.org/vim-team/neovim-qt

Package: neovim-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, neovim
Description: neovim client library and GUI
 neovim-qt provides a Qt5 GUI interface for neovim

=== debian/rules ===
--- 
+++ 
@@ -13,11 +13,11 @@
 TEST_HOME = $(CURDIR)/build/home
 
 %:
-	dh $@ --builddirectory=build
+	dh $@ --builddirectory=build --buildsystem=cmake+ninja
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release
-	$(MAKE) -C $(CURDIR)/build bindings
+	ninja -C $(CURDIR)/build bindings
 
 override_dh_auto_build:
 	dh_auto_build

## neovim-qt 0.2.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,9 @@
   cmake_policy(SET CMP0048 NEW)
 endif (POLICY CMP0048)
 
-project(neovim-qt VERSION 0.2.14.0)
+# Neovim-Qt Version, used by --version update before release
+# 9999 = Development Pre-Release
+project(neovim-qt VERSION 0.2.16.0)
 
 INCLUDE(CPack)
 
@@ -38,9 +40,10 @@
 # Qt
 set(CMAKE_AUTOMOC ON)
 find_package(Qt5Core REQUIRED)
+find_package(Qt5Network REQUIRED)
+find_package(Qt5Svg REQUIRED)
+find_package(Qt5Test REQUIRED)
 find_package(Qt5Widgets REQUIRED)
-find_package(Qt5Network REQUIRED)
-find_package(Qt5Test REQUIRED)
 
 # msgpack
 option(USE_SYSTEM_MSGPACK "Use system msgpack libraries " OFF)

=== doc/CMakeLists.txt ===

find_package(Doxygen)
if (DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
	add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		COMMENT "Generate API docs with doxygen" VERBATIM)
endif()

=== src/CMakeLists.txt ===

configure_file(version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(NEOVIM_QT_SOURCES
  auto/neovimapi0.cpp
  auto/neovimapi1.cpp
  auto/neovimapi2.cpp
  auto/neovimapi3.cpp
  auto/neovimapi4.cpp
  auto/neovimapi5.cpp
  auto/neovimapi6.cpp
  function.cpp
  msgpackiodevice.cpp
  msgpackrequest.cpp
  neovimconnector.cpp
  neovimconnectorhelper.cpp
  util.cpp)

if(WIN32)
  list(APPEND NEOVIM_QT_SOURCES stdinreader.cpp)
endif()

add_library(neovim-qt STATIC ${NEOVIM_QT_SOURCES})
target_link_libraries(neovim-qt Qt5::Network ${MSGPACK_LIBRARIES})

add_subdirectory(gui)

=== test/CMakeLists.txt ===
set(QTLIBS Qt5::Network Qt5::Svg Qt5::Test)

include_directories(${CMAKE_SOURCE_DIR}/src)
add_definitions(-DCMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\")
if (WIN32 AND USE_STATIC_QT)
	add_definitions(-DUSE_STATIC_QT)
endif ()

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

function(add_xtest SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${SOURCE_NAME}.cpp ${ARGV1} ${ARGV2})
	target_link_libraries(${SOURCE_NAME} ${QTLIBS} ${MSGPACK_LIBRARIES} neovim-qt)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

function(add_xtest_gui SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${SOURCE_NAME}.cpp)
	target_link_libraries(${SOURCE_NAME} ${QTLIBS} ${MSGPACK_LIBRARIES} neovim-qt Qt5::Widgets neovim-qt-gui)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME}
		# Run GUI tests from source dir, they depend on src files
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

function(add_shared_test SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${ARGV1} ${ARGV2} ${ARGV3})
	target_link_libraries(${SOURCE_NAME} Qt5::Network Qt5::Test Qt5::Widgets ${MSGPACK_LIBRARIES} neovim-qt)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

add_xtest(tst_neovimobject)
add_xtest(tst_neovimconnector)
add_xtest(tst_callallmethods)
add_xtest(tst_encoding)
add_xtest(tst_msgpackiodevice)
add_xtest_gui(tst_shell)

# Platform Specific Input Tests
add_xtest(tst_input_mac
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_mac.cpp)
add_xtest(tst_input_unix
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_unix.cpp)
add_xtest(tst_input_win32
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_win32.cpp)

# Platform Agnostic Input Tests
add_shared_test(tst_input_common_mac
	tst_input_common.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_mac.cpp)
add_shared_test(tst_input_common_unix
	tst_input_common.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_unix.cpp)
add_shared_test(tst_input_common_win32
	tst_input_common.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_win32.cpp)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,13 @@
-set(QTLIBS Qt5::Network Qt5::Widgets)
+set(QTLIBS Qt5::Network Qt5::Svg Qt5::Widgets)
 
 include_directories(.. shellwidget)
 qt5_add_resources(NEOVIM_RCC_SOURCES data.qrc)
 if(WIN32)
 	set(SRCS_PLATFORM
+		app_runtime.cpp
 		arguments_qwindowgeometry.cpp
+		input_win32.cpp
+		printinfo_msgbox.cpp
 		)
 	if (USE_STATIC_QT)
 		add_definitions(-DUSE_STATIC_QT)
@@ -15,7 +18,10 @@
 	enable_language(RC)
 elseif(APPLE)
 	set(SRCS_PLATFORM
+		app_runtime_mac.cpp
 		arguments_qwindowgeometry.cpp
+		input_mac.cpp
+		printinfo_stdout.cpp
 		)
 	set(ICON_PATH ${PROJECT_SOURCE_DIR}/third-party/neovim.icns)
 	set_source_files_properties(${ICON_PATH} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
@@ -23,7 +29,10 @@
 	set(MACOSX_BUNDLE_INFO_PLIST ${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in)
 else()
 	set(SRCS_PLATFORM
+		app_runtime.cpp
 		arguments_geometry.cpp
+		input_unix.cpp
+		printinfo_stdout.cpp
 		)
 endif()
 
@@ -35,20 +44,19 @@
 add_library(neovim-qt-gui
 	app.cpp
 	errorwidget.cpp
-	highlight.cpp
 	input.cpp
 	mainwindow.cpp
 	popupmenu.cpp
 	popupmenumodel.cpp
+	scrollbar.cpp
 	shell.cpp
 	treeview.cpp
 	${SRCS_PLATFORM}
 	${NEOVIM_RCC_SOURCES})
-
-target_link_libraries(neovim-qt-gui qshellwidget neovim-qt)
+target_link_libraries(neovim-qt-gui ${QTLIBS} qshellwidget neovim-qt)
 
 if(NOT APPLE)
-	set_property(SOURCE app.cpp PROPERTY COMPILE_DEFINITIONS
+	set_property(SOURCE app_runtime.cpp PROPERTY COMPILE_DEFINITIONS
 		NVIM_QT_RUNTIME_PATH="${CMAKE_INSTALL_FULL_DATADIR}/nvim-qt/runtime")
 endif()

=== src/gui/shellwidget/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,15 @@
 	add_definitions(-DUSE_STATIC_QT)
 endif ()
 
-set(SOURCES shellcontents.cpp helpers.cpp shellwidget.cpp konsole_wcwidth.cpp)
+set(SOURCES
+  cell.cpp
+  cursor.cpp
+  highlight.cpp
+  helpers.cpp
+  konsole_wcwidth.cpp
+  shellcontents.cpp
+  shellwidget.cpp)
+
 add_library(qshellwidget STATIC ${SOURCES})
 target_link_libraries(qshellwidget Qt5::Widgets)

=== debian/changelog ===
neovim-qt (0.2.16-1) unstable; urgency=medium

  * New upstream release
  * Add libqt5svg5-dev to Build-Depends
  * rules:
    + Pass PYTHON_EXECUTABLE=/usr/bin/python3 to cmake to ensure it picks up
      the right Python version
    + Workaround needing $DISPLAY to run "nvim-qt --help"
  * Remove tst_shell_start.jpg during clean
  * Bump debhelper compat to 13
  * Declare compliance with Policy 4.5.0, no changes needed

 -- James McCoy <jamessan@debian.org>  Tue, 23 Jun 2020 22:18:11 -0400

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
 Uploaders: Jason Pleau <jason@jpleau.ca>, James McCoy <jamessan@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                help2man,
                libmsgpack-dev (>= 1.4.0-2),
+               libqt5svg5-dev,
                neovim,
                ninja-build,
                python3-jinja2,
@@ -15,7 +16,7 @@
                xauth,
                neovim (>= 0.3.2) | xclip,
                xvfb
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/equalsraf/neovim-qt
 Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git

=== debian/rules ===
--- 
+++ 
@@ -16,12 +16,13 @@
 	dh $@ --builddirectory=build --buildsystem=cmake+ninja
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release
+	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release -DPYTHON_EXECUTABLE=/usr/bin/python3
 	ninja -C $(CURDIR)/build bindings
 
 override_dh_auto_build:
 	dh_auto_build
-	help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt
+	# Workaround bug where $DISPLAY is needed for --help
+	xvfb-run --auto-servernum help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt
 
 override_dh_auto_test:
 	mkdir -p "$(TEST_HOME)"
